\name{logsumexp}
\alias{logsumexp}
\title{ log(sum(exp())) }
\description{
  approximate log(sum(exp())) by iterated Taylor expansion
}
\usage{
logsumexp(v, cut = 0.5)
}
\arguments{
  \item{v}{ the input vector }
  \item{cut}{ cut off }
}
\details{
  suppose a is ordered from biggest to smallest. 
  y = log(exp(a[1]) + ... + exp(a[n])) = log(1 + exp(a[2] + ... + a[n] - n*a[1])), if the reminder: exp(a[2] + ... + a[n] - n*a[1]) < cut, approximate y by Taylor expansion. Otherwise, taking exp(a[1]) + exp(a[2]) as divider, let z = logsumexp(a[1:2]), y = log(1 + exp(a[3] + ... + a[n] - n*z))... Iterate until reminder smaller than cut or all the a[i] belong to divider except a[n].
}
\value{
    a number.
}
\references{  }
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

}
\keyword{ utilities }
